#ifndef _MSA_H_
#define _MSA_H_

#include "Util.h"
#include <map>

class MSA{
public:
	vector<string> names;
	map<string, string> species;
	int L; int N;
	
	MSA(){}
	MSA(const string & infile);
	MSA(const MSA & in_msa);
	void show(ostream & fout = cout);
	bool checkformat();
	bool isempty();
	string operator [] (const int & i);
	double gethydrogenbonds(const int & x, const int & y, const int & p);
	int name2indx(const string & name); 
	vector<int> compute_gap2ngap(const double & p_maxgap);//remove gappy columns (whose gap percentage > p_maxgap) from the msa, and return the gappy-to-nongappy vector
	MSA apply_gap2ngap(vector<int> & gap2ngap);//return a new MSA which is constructed by applying the gappy-to-nongappy vector to the current vector
private:
	void readfasta(const string & infile);
	void readclustalw(const string & infile);
	vector<double> gethygrogenbonds();
};
//string operator [] (const MSA & in_msa, const int i);
#endif
