#ifndef _UTIL_H_
#define _UTIL_H_

#include <cstdlib>
#include <cstdio>
#include <ctype.h> //for using tolower
#include <string>
#include <iostream>
#include <sstream>
#include <fstream>
#include <vector>
#include <stack>
#include <assert.h>
#include <utility>

#include <sys/types.h>
#include <unistd.h>
#include <sys/stat.h> //for checking if a file exists
#include <time.h>	    //for rand() and initializing seed
//#include <hash_map>//for hashing table
#include <unordered_set>
#include <algorithm> //for using abs
#include <iomanip>

using namespace std;

#define sz(x) (int)x.size()
#define FOR(i,a,b) for(int i=a;i<b;++i)
#define PB push_back
#define POP pop_back
#define MAXCHARNUM 50000
/*
#define MAXINWARDOVERLAP 0.25
#define MINLOOPLEN 3
#define ALLOWGU 1
#define MINSTACKLEN = 3;
#define MINHYDROGEN = 8;
*/
const int OO = 987654321; //infinite large
const double PRECISION = 1e-4;
const int UNIT = 100;//times 100

void readin(ifstream & fin, string & seq);
//check if a file exists or not
bool fexists(const char *filename);
string dna2rna(const string & seq);
double max(const double & d1, const double & d2);
double min(const double & d1, const double & d2);
int max(const int & d1, const int & d2);
int min(const int & d1, const int & d2);
string lowercase(const string & str);
string uppercase(const string & str);
string trim(const string & str);
void parseclustalline(const string & str, string & first, string & second);
int cmp(const char & a, const char & b);
bool match(const char & x , const char & y, bool allowgu = true);
int hydrogenbond(const char & x, const char & y);
char getcomplementchar(const char & x);
bool eq(const double & x, const double & y);
int myrand(int n); // Random number generator
void show(vector<vector<bool>> & vvb, ostream & fout = cout);
void show(vector<double> & vd, ostream & fout = cout);
void show(vector<vector<double>> & vvd, ostream & fout = cout);
void show(vector<int> & vi, ostream & fout = cout);
void show(vector<vector<int>> & vvi, ostream & fout = cout);
void showUpTriMatrix(vector<int> & vi, const int & blocksz, ostream & fout = cout);
//The length of in_str should be equivalent to the number of 1s in gap2ngap, in_str should be obtained through removing all the columns that are 0 in the gap2ngap vector from the originial string. 
string reverse_gap2ngap(const string & in_str, const vector<int> & gap2ngap);

#endif
