#ifndef _CLUSTERRS_H_
#define _CLUSTERRS_H_
#include "RNACons_Turner.h"
#include <utility>

const double samedirect = 0.5;

class stemstem {
public: 
	stem sti;
	stem stj;
	stemstem(){}
	stemstem(stem & in_sti, stem & in_stj) {
		sti = in_sti; stj = in_stj;
	}
};

bool operator == (const stemstem & stst1, const stemstem & stst2);
bool operator != (const stemstem & stst1, const stemstem & stst2);
bool operator <  (const stemstem & stst1, const stemstem & stst2);
bool operator >  (const stemstem & stst1, const stemstem & stst2);

vector<int> str2vectorint(const string & str);
vector<int> RStack2vectorint(const RStack & rs) ;

/* vi[.]= -1: value is not set;
   vi[.]= 0 : set to 0 for sure;
   vi[.]= 1 : set to 1 for sure;
   vi[.]= 2 : set to samedirect or greater; */

vector<int> compute_conflictingdegree_between_stems(stem & sti, stem & stj);
vector<int> get_conflictingdegree_between_stems(map<stemstem, vector<int>> & CDSTmap, stem & sti, stem & stj);
vector<double> compute_conflictingdegree(RNAConsT & in_rc, RStack & rs1, RStack & rs2, map<stemstem, vector<int>> & CDSTmap);
vector<double> compute_conflictingdegree(RNAConsT & in_rc, const string & s1, const string & s2, map<stemstem, vector<int>> & CDSTmap);
double compute_pairwise_conflictingdegree(RNAConsT & in_rc, 
       RStack & rs1, RStack & rs2, map<stem, int> & stemEmap, map<stemstem, vector<int>> & CDSTmap);



map<stem, int> computeStemE(RNAConsT & in_rc, vector<stem> & vst);//compute stacking energy of all stems in vst and return a map mapping stems to their energies (which are integers);
int getStemE(RNAConsT & in_rc, stem & st, map<stem, int> & stemEmap);//obtain the stacking energy of stem st from map stemEmap, if it is not available, call computeS and add it to stemEmap.


#endif
